]> code.delx.au - gnu-emacs/blob - make-dist
*** empty log message ***
[gnu-emacs] / make-dist
1 #!/bin/sh
2 #
3 # make-dist: create an Emacs distribution tar file from the current
4 # source tree. This basically creates a duplicate directory
5 # structure, and then hard links into it only those files that should
6 # be distributed. This means that if you add a file with an odd name,
7 # you should make sure that this script will include it.
8
9 progname="$0"
10
11 # Exit if a command fails.
12 # set -e
13
14 # Print out each line we read, for debugging's sake.
15 # set -v
16
17 clean_up=yes
18 make_tar=yes
19 newer=""
20
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 # This option tells make-dist not to delete the staging directory
24 # after it's done making the tar file.
25 "--no-clean-up" )
26 clean_up=no
27 ;;
28 # This option tells make-dist not to make a tar file. Since it's
29 # rather pointless to build the whole staging directory and then
30 # nuke it, using this option also selects '--no-clean-up'.
31 "--no-tar" )
32 make_tar=no
33 clean_up=no
34 ;;
35 # This option tells make-dist to make the distribution normally, then
36 # remove all files newer than the given timestamp file. This is useful
37 # for creating incremental or patch distributions
38 "--newer")
39 newer="$2"
40 new_extension=".new"
41 shift
42 ;;
43 * )
44 echo "${progname}: Unrecognized argument: $1" >&2
45 exit 1
46 ;;
47 esac
48 shift
49 done
50
51 # Make sure we're running in the right place.
52 if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
53 echo "${progname}: Can't find \`src/lisp.h' and \`lisp/version.el'." >&2
54 echo "${progname} must be run in the top directory of the Emacs" >&2
55 echo "distribution tree. Cd to that directory and try again." >&2
56 exit 1
57 fi
58
59 # Find out which version of Emacs this is.
60 version=`grep 'defconst[ ]*emacs-version' lisp/version.el \
61 | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\)\..*$/\1/'`
62 if [ ! "${version}" ]; then
63 echo "${progname}: can't find current emacs version in \`./lisp/version.el'." >&2
64 exit 1
65 fi
66
67 # Make sure the subdirectory is available.
68 tempparent="make-dist.tmp.$$"
69 if [ -d ${tempparent} ]; then
70 echo "${progname}: staging directory \`${tempparent}' already exists.
71 Perhaps a previous invocation of \`${progname}' failed to clean up after
72 itself. Check that directories whose names are of the form
73 \`make-dist.tmp.NNNNN' don't contain any important information, remove
74 them, and try again." >&2
75 exit 1
76 fi
77
78 echo "Creating staging directory: \`${tempparent}'"
79 mkdir ${tempparent}
80 emacsname="emacs-${version}${new_extension}"
81 tempdir="${tempparent}/${emacsname}"
82
83 # This trap ensures that the staging directory will be cleaned up even
84 # when the script is interrupted in mid-career.
85 if [ "${clean_up}" = yes ]; then
86 trap "echo 'Interrupted...cleaning up the staging directory.'; rm -rf ${tempparent}; exit 1" 1 2 15
87 fi
88
89 echo "Creating top directory: \`${tempdir}'"
90 mkdir ${tempdir}
91
92 # We copy in the top-level files before creating the subdirectories in
93 # hopes that this will make the top-level files appear first in the
94 # tar file; this means that people can start reading the INSTALL and
95 # README while the rest of the tar file is still unpacking. Whoopee.
96 echo "Making links to top-level files."
97 ln GETTING.GNU.SOFTWARE INSTALL PROBLEMS README move-if-change ${tempdir}
98 ln ChangeLog Makefile.in build-install.in configure config.sub ${tempdir}
99 ln make-dist ${tempdir}
100
101 echo "Creating subdirectories."
102 for subdir in lisp lisp/term local-lisp external-lisp \
103 src src/m src/s lib-src oldXMenu \
104 etc lock arch-lib cpp info man shortnames vms; do
105 mkdir ${tempdir}/${subdir}
106 done
107
108 echo "Making links to \`lisp'."
109 # Don't distribute =*.el files, site-init.el, site-load.el, or default.el.
110 (cd lisp
111 ln [a-zA-Z]*.el ../${tempdir}/lisp
112 ln [a-zA-Z]*.elc ../${tempdir}/lisp
113 # simula.el doesn't keep abbreviations in simula.defns any more.
114 # ln [a-zA-Z]*.defns ../${tempdir}/lisp
115 ln ChangeLog README ../${tempdir}/lisp
116 cd ../${tempdir}/lisp
117 rm -f site-init site-init.el site-init.elc
118 rm -f site-load site-load.el site-load.elc
119 rm -f default default.el default.elc)
120
121 echo "Making links to \`lisp/term'."
122 # Don't distribute =*.el files.
123 (cd lisp/term
124 ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
125 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
126 ln README ../../${tempdir}/lisp/term)
127
128 echo "Making links to \`external-lisp'."
129 # Don't distribute =*.el files.
130 (cd external-lisp
131 ln [a-zA-Z]*.el ../${tempdir}/external-lisp
132 ln [a-zA-Z]*.elc ../${tempdir}/external-lisp
133 ln ChangeLog README ../${tempdir}/external-lisp)
134
135 echo "Making links to \`src'."
136 # Don't distribute =*.[ch] files, or the configured versions of
137 # config.h.in, paths.h.in, or Makefile.in.
138 (cd src
139 ln [a-zA-Z]*.c ../${tempdir}/src
140 ln [a-zA-Z]*.h ../${tempdir}/src
141 ln [a-zA-Z]*.s ../${tempdir}/src
142 ln README Makefile.in ymakefile ChangeLog config.h.in paths.h.in \
143 ../${tempdir}/src
144 ln .gdbinit .dbxinit ../${tempdir}/src
145 ln *.com *.opt vms-pp.trans vmsbuild ../${tempdir}/src
146 cd ../${tempdir}/src
147 rm -f config.h paths.h Makefile
148 if [ -z "${newer}" ]; then
149 etags *.h *.c ../lisp/*.el
150 fi)
151
152 echo "Making links to \`src/m'."
153 (cd src/m
154 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/m)
155
156 echo "Making links to \`src/s'."
157 (cd src/s
158 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/s)
159
160 echo "Making links to \`lib-src'."
161 (cd lib-src
162 ln [a-zA-Z]*.[chy] [a-zA-Z]*.lex [a-zA-Z]*.com ../${tempdir}/lib-src
163 ln ChangeLog Makefile.in README testfile vcdiff rcs2log ../${tempdir}/lib-src
164 ln emacs.csh ../${tempdir}/lib-src
165 cd ../${tempdir}/lib-src
166 rm -f getdate.c getdate.tab.c y.tab.c y.tab.h)
167
168 echo "Making links to \`oldXMenu'."
169 (cd oldXMenu
170 ln *.c *.h ../${tempdir}/oldXMenu
171 ln README Makefile Imakefile ChangeLog ../${tempdir}/oldXMenu)
172
173 echo "Making links to \`etc'."
174 # Don't distribute DOC files, backups, autosaves, or tex litter.
175 (cd etc
176 ln [0-9a-zA-Z]* ../${tempdir}/etc
177 cd ../${tempdir}/etc
178 # Avoid an error when expanding the wildcards later.
179 for dummy in DOC-dummy dummy~ \#dummy\# dummy.dvi dummy.log; do
180 ln MACHINES ${dummy}
181 done
182 rm -f DOC* *~ \#*\# *.dvi *.log core)
183
184 # For now, we comment these out, since I'm not changing them any.
185 #!! echo "Making links to \`cpp'."
186 #!! (cd cpp
187 #!! ln cccp.c cexp.y Makefile README ../${tempdir}/cpp)
188 #!!
189 #!! echo "Making links to \`info'."
190 #!! # Don't distribute backups or autosaves.
191 #!! (cd info
192 #!! ln [a-zA-Z]* ../${tempdir}/info
193 #!! cd ../${tempdir}/info
194 #!! # Avoid an error when expanding the wildcards later.
195 #!! ln emacs dummy~ ; ln emacs \#dummy\#
196 #!! rm -f *~ \#*\# core)
197 #!!
198 #!! echo "Making links to \`man'."
199 #!! (cd man
200 #!! ln *.tex *.texinfo *.texi *.aux *.cps *.fns *.kys *.vrs ../${tempdir}/man
201 #!! ln *.c ../${tempdir}/man
202 #!! ln ChangeLog Makefile README split-man ../${tempdir}/man)
203
204 echo "Making links to \`shortnames'."
205 (cd shortnames
206 ln *.c ../${tempdir}/shortnames
207 ln Makefile reserved special ../${tempdir}/shortnames)
208
209 echo "Making links to \`vms'."
210 (cd vms
211 ln [0-9a-zA-Z]* ../${tempdir}/vms
212 cd ../${tempdir}/vms
213 rm -f *~)
214
215 ### On the GNU machines, these files are symbolic links to files on
216 ### another device, meaning that we can't make hard links to them in
217 ### the staging directory. I can't think of a better solution, so I
218 ### just have a special kludge here which knows exactly which files
219 ### this might happen to and copies them if they don't seem to have
220 ### been linked.
221 echo "Making sure we got all the files that may be cross-device"
222 echo "symbolic links."
223 for file in ./config.sub ./src/gmalloc.c ; do
224 if [ ! -f ${tempdir}/${file} ] ; then
225 echo " \`${file}' was missed; copying it."
226 cp ${file} ${tempdir}/${file}
227 fi
228 done
229
230 echo "Making sure copying notices are all symlinks to \`etc/COPYING'."
231 rm -f ${tempdir}/etc/COPYING
232 cp etc/COPYING ${tempdir}/etc/COPYING
233 for subdir in lisp external-lisp src lib-src info shortnames; do
234 if [ -f ${tempdir}/${subdir}/COPYING ]; then
235 rm ${tempdir}/${subdir}/COPYING
236 fi
237 ln -s ../etc/COPYING ${tempdir}/${subdir}
238 done
239
240 if [ "${newer}" ]; then
241 echo "Removing files older than $newer."
242 # We remove .elc files unconditionally, on the theory that anyone picking
243 # up an incremental distribution already has a running Emacs to byte-compile
244 # them with.
245 find ${tempparent} \( -name '*.elc' -o ! -newer ${newer} \) -exec rm -f {} \;
246 fi
247
248 if [ "${make_tar}" = yes ]; then
249 echo "Creating tar file."
250 (cd ${tempparent}; tar cvf - ${emacsname}) | compress > ${emacsname}.tar.Z
251 fi
252
253 if [ "${clean_up}" = yes ]; then
254 echo "Cleaning up the staging directory."
255 rm -rf ${tempparent}
256 fi
257
258 # make-dist ends here